=== debian/control ===
Source: ros-melodic-psen-scan
Section: misc
Priority: optional
Maintainer: Alexander Gutenkunst <a.gutenkunst@pilz.de>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-code-coverage, ros-melodic-pilz-testutils, ros-melodic-roscpp, ros-melodic-roslaunch, ros-melodic-rostest, ros-melodic-rosunit, ros-melodic-sensor-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-psen-scan
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-roscpp, ros-melodic-roslaunch, ros-melodic-rviz, ros-melodic-sensor-msgs
Description: The psen_scan package for Pilz laser scanner
